/* addrslv.h --- Address resolver interface

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef ADDRSLV_H
#define ADDRSLV_H 

#include <pmaps.h>
#include <glib.h>

typedef struct _AddrslvSymbolInfo AddrslvSymbolInfo;
struct _AddrslvSymbolInfo
{
  /* <public/> */
  gchar * funcname;
  
  guint address;
  guint size;
  gboolean dynamic;
  
  GQuark  srcfile_quark;
  guint   lineno;

  /* <private/> */
  guint   ref_count;
};

GQuark addrslv_bfd_error_quark (void);
#define ADDRSLV_BFD_ERROR addrslv_bfd_error_quark()

void                addrslv_init             (void);
void                addrslv_fin              (void);
AddrslvSymbolInfo*  addrslv_resolve          (PMaps * pmaps, guint address, GError ** err);
AddrslvSymbolInfo*  addrslv_reverse_resolve  (PMaps * pmaps, 
					      PMapsEntry * entry,
					      const gchar * funcname,
					      GError ** err);

AddrslvSymbolInfo*  addrslv_symbolinfo_ref   (AddrslvSymbolInfo * symbol_info);
void                addrslv_symbolinfo_unref (AddrslvSymbolInfo * symbol_info);

#endif /* Not def: ADDRSLV_H */

/* arch-tag: 28a5e7d8-bbbf-4931-8414-1a600bc87250
   (do not change this comment) */
