#include <pmaps.h>
#include "mainpos.h"

#define SUCCESSFUL 77

int
main(int argc, char ** argv)
{
  PMaps * pmaps;
  pid_t pid;
  PMapsEntry * main_entry;
  GError * err = NULL;
  
  pid = getpid();
  pmaps = pmaps_new(pid, &err);
  if (pmaps == NULL) 
    {
      g_warning ("Creating a PMaps is failed: %s\n", 
		 err->message);
      g_error_free(err);
      return 1;
    }
  
  main_entry = mainpos_find(pmaps, &err);
  if (main_entry == NULL) 
    return 2;
  
  g_message ("main() is at \"%s\"", main_entry->filename);
  
  pmaps_unref(pmaps);
  return SUCCESSFUL;
} 

/* arch-tag: 15a13a4f-426d-4b7d-8592-6553e0cabcc7
   (do not change this comment) */
