/* gset.h --- unordered pointer container

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef __GSET_H__
#define __GSET_H__ 

#include <glib.h>

G_BEGIN_DECLS

typedef struct _GSet GSet;
typedef gpointer (* GSetCopyFunc) (gconstpointer src);

GSet*     g_set_new      (GCompareFunc    compare_func,
			  GSetCopyFunc    copy_func,
			  GDestroyNotify  destroy_func);
void      g_set_destroy  (GSet * set);

void      g_set_add      (GSet * set, gconstpointer data);
gboolean  g_set_contains (GSet * set, gconstpointer data);

void      g_set_remove     (GSet * set, gconstpointer data);
gpointer  g_set_choose_any (GSet * set);
gpointer  g_set_pick_any   (GSet * set);

guint     g_set_count    (GSet * set);
void      g_set_foreach  (GSet            *set,
			  GFunc   	   func,
			  gpointer	   user_data);

G_END_DECLS

#endif /* Not def: __GSET_H__ */

/* arch-tag: 03058e97-6c94-4695-819c-a3a02764b491
   (do not change this comment) */
