#include "gset.h"
#include <string.h>

#define SUCCESSFUL 77

int
main(int argc, char ** argv)
{
  GSet * set;
  gpointer cat;
  set = g_set_new(strcmp, g_strdup, g_free);

  g_set_add (set, "dog");
  g_set_add (set, "cat");

  g_assert(g_set_contains(set, "dog"));
  g_assert(g_set_contains(set, "cat"));
  g_assert(g_set_contains(set, "pig") == FALSE);

  g_set_remove(set, "dog");
  g_assert(g_set_contains(set, "dog") == FALSE);
  g_assert(g_set_contains(set, "cat"));
  g_assert(g_set_contains(set, "pig") == FALSE);
  
  g_assert(g_set_count(set) 			== 1);
  g_assert(strcmp(g_set_choose_any(set), "cat") == 0);
  cat = g_set_pick_any(set);
  g_assert(cat && (strcmp(cat, "cat") == 0));
  g_assert(g_set_count(set) 			== 0);
  g_set_destroy(set);
  
  g_message("All tests are passed.");
  return SUCCESSFUL;
} 

/* arch-tag: 172342bf-93c3-46be-aaef-de2e051300e9
   (do not change this comment) */
