/* environ_service.h --- environ private decls

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef __GTRACER_ENVIRON_SERVICE_H__
#define __GTRACER_ENVIRON_SERVICE_H__ 

#include <gtk/gtk.h>

G_BEGIN_DECLS

void            gtracer_environ_viewer_init  (GError ** err);

GtkTreeModel*   gtracer_environ_model_new (void);
void            gtracer_environ_model_update(GtkTreeModel* model);

gint gtracer_environ_model_comapre_func (GtkTreeModel *model,
					 GtkTreeIter *a,
					 GtkTreeIter *b,
					 gpointer user_data);

void gtracer_environ_model_extract_key   (GtkTreeViewColumn *col,
					  GtkCellRenderer   *renderer,
					  GtkTreeModel      *model,
					  GtkTreeIter       *iter,
					  gpointer           user_data);
void gtracer_environ_model_extract_value (GtkTreeViewColumn *col,
					  GtkCellRenderer   *renderer,
					  GtkTreeModel      *model,
					  GtkTreeIter       *iter,
					  gpointer           user_data);

void gtracer_environ_model_edit_value    (GtkTreeModel* model, 
					  GtkTreeIter * iter, 
					  const gchar * new_text);

G_END_DECLS

#endif /* Not def: __GTRACER_ENVIRON_SERVICE_H__ */

/* arch-tag: 8c47902c-5ba6-47b1-a966-c2d680c3a1ba
   (do not change this comment) */
