/* proxy_service.c --- proxy common routines

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#include "service.h"
#include "proxy_service.h"

void
gtracer_proxy_service_init (GError ** err)
{
  GError * tmp_error = NULL;
  gtracer_proxy_log_class_init(&tmp_error);
  if (tmp_error) 
    {
      g_propagate_error(err, tmp_error);
      return ;
    }
  
  gtracer_proxy_viewer_init(&tmp_error);
  if (tmp_error) 
    {
      g_propagate_error(err, tmp_error);
      return ;
    }
  
  gtracer_proxy_filter_init (&tmp_error);
  if (tmp_error) 
    {
      g_propagate_error(err, tmp_error);
      return ;
    }
}

gboolean
gtracer_log_is_proxy  (GTracerLogProtected * log)
{
  return gtracer_log_is(log, GTRACER_PROXY_LOG_NAME);
}
  
/* arch-tag: 09ee4efd-dab6-4103-97f3-bbffacea51fb
   (do not change this comment) */
