/* source_service.h --- decls of source log service

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef __GTRACER_SOURCE_SERVICE_H__
#define __GTRACER_SOURCE_SERVICE_H__ 

#include "plugin.h"
#include "gtracer.h"
#include <glib.h>

G_BEGIN_DECLS

void gtracer_source_viewer_init    (GError ** err);
void gtracer_source_log_class_init (GError ** err);
void gtracer_source_filter_init    (GError ** err);

typedef struct _GTracerSourceLog  GTracerSourceLog;
typedef struct _GTracerDropsrcLog GTracerDropsrcLog;

guint    gtracer_source_log_tag       (GTracerSourceLog * log);
gint     gtracer_source_log_priority  (GTracerSourceLog * log);
guint    gtracer_source_log_interval  (GTracerSourceLog * log);
gpointer gtracer_source_log_function  (GTracerSourceLog * log);
GSList*  gtracer_source_log_backtrace (GTracerSourceLog * log);

guint    gtracer_dropsrc_log_tag      (GTracerDropsrcLog * log);

G_END_DECLS

#endif /* Not def: __GTRACER_SOURCE_SERVICE_H__ */

/* arch-tag: 2e3809b8-4828-41bc-951e-bb490a045b3b
   (do not change this comment) */
