/* utils.h --- decls of common miscellaneous functions

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */


#ifndef __GTRACER_UTILS_H__
#define __GTRACER_UTILS_H__ 

#include <gtk/gtk.h>

G_BEGIN_DECLS

void gtracer_register_tree_view_column (GtkTreeViewColumn * tree_view_column);

typedef struct _GTracerIterStack GTracerIterStack;
GTracerIterStack*  gtracer_iter_stack_new(void);
void               gtracer_iter_stack_clear(GTracerIterStack* stack);
GtkTreeIter *      gtracer_iter_stack_current_iter(GTracerIterStack* stack);
GtkTreeIter *      gtracer_iter_stack_parent_iter(GTracerIterStack* stack);
void               gtracer_iter_stack_pop(GTracerIterStack* stack);
GtkTreeIter *      gtracer_iter_stack_push_alloc(GTracerIterStack* stack);

gpointer           g_ptr_array_last(GPtrArray * array);

/* ------------------------------------------------------------------
   Temporary helper function for adding menu items to g-inspector's 
   main window.
   ------------------------------------------------------------------ */
void
g_tracer_append_menu_item (gchar *item_path,
			   gchar *item_type,
			   gchar *func_name);


G_END_DECLS

#endif /* Not def: __GTRACER_UTILS_H__ */

/* arch-tag: 34c63976-8d93-4377-a2d8-2d7d1232f920
   (do not change this comment) */
