/* loader.h --- interface of memory mapping loader

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef __LOADER_H__
#define __LOADER_H__ 

#include "pmaps.h"

/* Functions exported from pmaps.c to loaders. */
pid_t         pmaps_get_pid          (PMaps * pmaps);
gpointer      pmaps_get_loader_data  (PMaps * pmaps);
void          pmaps_set_loader_data  (PMaps * pmaps, gpointer loader_data);
void          pmaps_add_entry(PMaps * pmaps,
			      guint start, guint end, 
			      guint prot, 
			      gchar * filename);

/* Functions exported from loaders to pmaps.c. */
typedef struct _PMapsLoader PMapsLoader;
struct _PMapsLoader
{
  gboolean (* init)         (PMaps* pmaps, GError** err);
  gboolean (* load)         (PMaps* pmaps, GError** err);
  void     (* fin)          (PMaps* pmaps);
};

extern PMapsLoader* pmaps_maps_loader;
extern PMapsLoader* pmaps_pmap_loader;

#endif /* Not def: __LOADER_H__ */

/* arch-tag: c05b58ec-d838-4852-97ea-891fa90271d1
   (do not change this comment) */
