#include <pmaps.h>

#define SUCCESSFUL 77

void entry_printer(PMapsEntry * entry, gpointer user_data);

int
main(int argc, char ** argv)
{
  PMaps * pmaps;
  GError * err = NULL;
  guint pid = getpid();

  pmaps = pmaps_new(pid, &err);
  if (pmaps == NULL)
    {
      g_warning("Creating a PMaps is failed: %s\n", 
		err->message);
      g_error_free(err);
      return 1;
    }

  pmaps_dump(pmaps, "before");

  if (pmaps_update(pmaps, &err) == FALSE)
    {
      g_warning("Updating a PMaps is failed: %s\n", 
		err->message);
      g_error_free(err);
      return 1;
    }
  pmaps_dump(pmaps, "after");
  
  pmaps_unref(pmaps);
  return SUCCESSFUL;
} 

/* arch-tag: c1d65462-1161-48e0-ae59-af59145a2cbf
   (do not change this comment) */
