/* preload.h --- preload common functions

   Copyright (c) 2004, 2005 by Masatake YAMATO and Red Hat, Inc.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

   - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.  

   - Neither the name of Red Hat, Inc nor the names of its
   contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGE. */

/* Development of the code in this file is support of 
   Information-technology Promotion Agency(IPA), Japan. */

#ifndef __GTRACER__PRELOAD_H__
#define __GTRACER__PRELOAD_H__ 

#include "gtracer.h"
#include <dlfcn.h>

G_BEGIN_DECLS

#ifndef RTLD_NEXT
#  define RTLD_NEXT ((void*) (long) -1)
#endif

#define GENUINE_GET() G_STMT_START{				\
    if (G_UNLIKELY(!GENUINE))					\
      GENUINE = dlsym(RTLD_NEXT, __FUNCTION__);			\
    if (G_UNLIKELY(!GENUINE))					\
      g_error ("genuine `%s' is not found.", __FUNCTION__);	\
} G_STMT_END

extern gboolean gtracer_preload_ready;
#define CUTIN_VAR gboolean cutin = gtracer_preload_ready
#define CUTIN if(cutin)
#define CUTIN_IF_PRE(extra_condtion)   if ((extra_condtion) && cutin)
#define CUTIN_IF_POST(extra_condtion)  if ((extra_condtion) && cutin)

gpointer    gtracer_preload_get_log_constructor (gchar * log_name);
void        gtracer_preload_queue_push_log      (GTracerLog * log);

GTracerLog* gtracer_preload_log_ref             (GTracerLog * log);
void        gtracer_preload_log_unref           (GTracerLog * log);

gboolean    gtracer_is_object_zombie(GObject * object);

#endif /* Not def: __GTRACER__PRELOAD_H__ */

G_END_DECLS

/* arch-tag: 75318b00-a08b-40bd-b8fb-056a35051c6c
   (do not change this comment) */
